import * as React from "react";
declare type SetArrayValues<T> = React.Dispatch<React.SetStateAction<T[]>>;
declare type Pop = () => void;
declare type Push<T> = (value: T) => void;
declare type Shift = () => void;
declare type Unshift<T> = (value: T) => void;
declare type Reverse = () => void;
declare type RemoveByIndex = (index: number) => void;
declare type RemoveByValue<T> = (value: T) => void;
declare type Filter<T> = (predicate: (value: T, index: number, array: T[]) => value is T, thisArg?: any) => void;
declare type InsertItem<T> = (index: number, value: T) => void;
declare type MoveItem = (fromIndex: number, toIndex: number) => void;
interface Return<T> {
    pop: Pop;
    push: Push<T>;
    shift: Shift;
    unshift: Unshift<T>;
    reverse: Reverse;
    removeByIndex: RemoveByIndex;
    removeByValue: RemoveByValue<T>;
    filter: Filter<T>;
    insertItem: InsertItem<T>;
    moveItem: MoveItem;
    values: T[];
    setValues: SetArrayValues<T>;
}
declare const useImmutableArray: <T>(array: T[]) => Return<T>;
export default useImmutableArray;
